Subject: Re: bug#819: 23.0.60; group and owner "Everyone" - what's that about?

From: Eli Zaretskii <[email-masked]>
Date: Fri, 29 Aug 2008 22:22:58 +0300

> From: "Drew Adams" <[email-masked]>
> Cc: <[email-masked]>, <[email-masked]>
> Date: Fri, 29 Aug 2008 11:12:35 -0700
> 
> In Emacs 23, it's not what I see in Dired for the other files and directories,
> besides `..'. In my case, I see my user name as the owner for each entry except
> `..', and I see `None' as the group for each entry except `..'.

"None" is the name of the primary group on a stand-alone workstation
(probably because someone at MS thought that groups only make sense
when there's a domain server).  If your machine is a stand-alone
workstation, "None" is what I'd expect.

> In Emacs 22, I see my user name as the owner for each entry (including `..') and
> `root' as the group for each entry (including `..'). In Emacs 20, I see my user
> name as the owner for each entry (including `..') and `5' as the group for each
> entry (including `..').

This code evolved since it was written.  Emacs 20 to 22 didn't
actually ask the filesystem for the owner and primary group of each
file.  Instead, they retrieved during startup the name of the user who
runs Emacs, and then attributed each file to that user, and just
invented its group as "root".  (`5' in Emacs 20 is just due to a bug
in understanding the components of the Windows Security ID
descriptor.)  In Emacs 23, we ask the filesystem about the owner and
the group, and report that if the information is available.

This is why each version behaves differently.  But it is important to
know that before Emacs 23, the displayed info was largely invented
rather than extracted from the filesystem.  Now you see what is really
there (if you are on NTFS, which is not your case, see below).

> And why should following the link `..' show something different from what was
> shown for `..' in the subdir?

You mean the link `.' (on dot) should show the same as what was shown
for `..' (2 dots) in a subdir, right?  If that's not happening for
you, please show a concrete example.

> My hard disk is formatted FAT32, not NTFS.

On a FAT32 we currently attribute all files and directories to the
user who runs Emacs.  FAT32 fails the file-security syscalls, so we
fall back on what Emacs 22 did, because files that have no owner are
in a way ``owned'' by everyone, the current user included.

> Whatever is used should be consistent: (1) `..' shouldn't be special

`..' isn't treated special in the Emacs code that deals with file
ownership.

> and (2)
> `..' should show the same properties (owner group) as what is shown for it when
> you follow the `..' link - the directory's properties should not change
> depending on where you are looking at them.

If you follow the `..' link twice, you mean, right?  Or if you follow
it once, then look at the `.' line.  Right?